use master
if exists(select * from master.dbo.sysobjects where name = 'sp_blocked')
    drop procedure sp_blocked
go
create procedure sp_blocked
    @spid int
as
create table #Blocked
(spid int)
insert into #Blocked
(spid)
values
(@spid)

while @@ROWCOUNT <> 0
BEGIN
    insert into #Blocked
    (spid)
    select spid 
        from master.dbo.sysprocesses 
        where blocked in (select spid from #Blocked)
        and spid not in (select spid from #Blocked)
END

delete from #Blocked
where spid = @spid

if exists(select * from #Blocked)
BEGIN
    select *
    from master.dbo.sysprocesses
    where spid in (select spid from #Blocked)
END
else
BEGIN
    select 'No Processes are being blocked by spid ' + convert(varchar(20), @spid) + '.' as 'System Message'
END

drop table #Blocked
go
print 'sp_blocked created.'



USE master
print 'Creating sp_who3'

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[sp_who3]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[sp_who3]
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE procedure sp_who3
    @spid sysname = null
as
SET NOCOUNT ON
if @spid is null
BEGIN
    exec sp_who2
END
ELSE
BEGIN
    if lower(convert(varchar(10), @spid)) = 'active'
    BEGIN
        exec sp_who2 active
    END
    ELSE
    BEGIN
        declare @spid_i int
        set @spid_i = @spid
        exec sp_who @spid_i
        exec sp_who2 @spid_i
        dbcc inputbuffer (@spid_i)
        select * from master.dbo.sysprocesses where spid = @spid_i
        exec sp_blocked @spid_i
        exec sp_lock @spid_i
    END
END
GO
grant exec on sp_who3 to public
go